## piuparts 1.4.4

=== Makefile ===
prefix = /usr/local
sbindir = $(prefix)/sbin
sharedir = $(prefix)/share
mandir = $(sharedir)/man
man1dir = $(mandir)/man1
man8dir = $(mandir)/man8
libdir = $(prefix)/lib
docdir = $(prefix)/share/doc/piuparts
site3 = $(libdir)/python3/dist-packages
htdocsdir	 = $(sharedir)/piuparts/htdocs
etcdir = $(prefix)/etc

distribution=${shell dpkg-parsechangelog -SDistribution}
version = ${shell dpkg-parsechangelog -SVersion}
ifeq ($(distribution),UNRELEASED)
ifeq (,$(findstring salsaci,$(version)))
version	= ${shell echo "`dpkg-parsechangelog -SVersion`~`date +%Y%m%d%H%M`~`git describe --dirty`"}
endif
endif

# generate several scripts, conffiles, ... from templates (*.in, *.py)
# by substituting placeholders
SCRIPTS_TEMPLATES	 = $(wildcard *.in master-bin/*.in slave-bin/*.in conf/*.in)
SCRIPTS_PYTHON_BINARY	 = $(wildcard *.py master-bin/*.py slave-bin/*.py)
SCRIPTS_GENERATED	 = $(SCRIPTS_TEMPLATES:.in=) $(SCRIPTS_PYTHON_BINARY:.py=)
DOCS_GENERATED		 = piuparts.1 piuparts_slave_run.8 piuparts_slave_join.8 piuparts_slave_stop.8 docs/build

define placeholder_substitution
	sed -r \
	-e 's/__PIUPARTS_VERSION__/$(version)/g' \
	-e 's%@libdir@%$(libdir)%g' \
	-e 's%@sharedir@%$(sharedir)%g' \
	-e 's%@sbindir@%$(sbindir)%g' \
	$< > $@
endef

%: %.in Makefile
	$(placeholder_substitution)

%: %.py Makefile
	$(placeholder_substitution)


all: build

python_scripts	 = $(wildcard *.py piupartslib/*.py master-bin/*.py slave-bin/*.py)
python-syntax-check:
	@set -e -x; $(foreach py,$(python_scripts),python3 -m py_compile $(py);)
	$(RM) $(python_scripts:=c)

build: build-stamp build-master-stamp
build-slave: build-stamp
build-master: build-stamp build-master-stamp

build-stamp: $(SCRIPTS_GENERATED) $(DOCS_GENERATED) Makefile
	$(MAKE) -C instances
	$(MAKE) python-syntax-check
	touch $@

build-master-stamp:
	(cd helpers/debiman-piuparts-distill && go build -buildvcs=false)
	touch $@

build-doc: $(DOCS_GENERATED)

docs/build:
	python3 -m sphinx docs/ docs/build/

piuparts.1: docs/piuparts/piuparts.1.txt
	python3 -m sphinx -b man -c docs/piuparts/ docs/piuparts/ ./

piuparts_slave_run.8: docs/piuparts_slave_run/piuparts_slave_run.8.txt
	python3 -m sphinx -b man -c docs/piuparts_slave_run/ docs/piuparts_slave_run/ ./

piuparts_slave_join.8: docs/piuparts_slave_join/piuparts_slave_join.8.txt
	python3 -m sphinx -b man -c docs/piuparts_slave_join/ docs/piuparts_slave_join/ ./

piuparts_slave_stop.8: docs/piuparts_slave_stop/piuparts_slave_stop.8.txt
	python3 -m sphinx -b man -c docs/piuparts_slave_stop/ docs/piuparts_slave_stop/ ./

install-doc: build-stamp
	# txt
	install -d $(DESTDIR)$(docdir)/
	install -d $(DESTDIR)$(docdir)/html/
	install -m 0644 docs/README.txt docs/README_server.txt $(DESTDIR)$(docdir)/
	# html
	cp -r docs/build/* $(DESTDIR)$(docdir)/html/
	# manpages
	install -d $(DESTDIR)$(man1dir)
	install -m 0644 piuparts.1 $(DESTDIR)$(man1dir)/
	gzip -9fn $(DESTDIR)$(man1dir)/piuparts.1
	install -d $(DESTDIR)$(man8dir)
	install -m 0644 piuparts_slave_run.8 piuparts_slave_join.8 piuparts_slave_stop.8 $(DESTDIR)$(man8dir)/
	gzip -9fn $(DESTDIR)$(man8dir)/piuparts_slave_run.8
	gzip -9fn $(DESTDIR)$(man8dir)/piuparts_slave_join.8
	gzip -9fn $(DESTDIR)$(man8dir)/piuparts_slave_stop.8

install-conf: build-stamp
	install -d $(DESTDIR)$(etcdir)/piuparts
	install -m 0644 conf/piuparts.conf.sample $(DESTDIR)$(etcdir)/piuparts/piuparts.conf
	install -m 0644 conf/distros.conf $(DESTDIR)$(etcdir)/piuparts/
	install -d $(DESTDIR)$(etcdir)/apache2/conf-available
	install -m 0644 conf/piuparts-master.conf $(DESTDIR)$(etcdir)/apache2/conf-available/

install-conf-4-running-from-git: build-stamp
	install -d $(DESTDIR)$(etcdir)/piuparts
	install -m 0644 conf/crontab-master $(DESTDIR)$(etcdir)/piuparts/
	install -m 0644 conf/crontab-slave $(DESTDIR)$(etcdir)/piuparts/
	install -m 0644 conf/distros.conf $(DESTDIR)$(etcdir)/piuparts/
	install -m 0644 instances/piuparts.conf.* $(DESTDIR)$(etcdir)/piuparts/
	install -d $(DESTDIR)$(sharedir)/piuparts/slave
	install -m 0755 update-piuparts-slave-setup $(DESTDIR)$(sharedir)/piuparts/slave/
	install -d $(DESTDIR)$(sharedir)/piuparts/master
	install -m 0755 update-piuparts-master-setup $(DESTDIR)$(sharedir)/piuparts/master/

install-common: build-stamp
	install -d $(DESTDIR)$(site3)/piupartslib
	install -m 0644 piupartslib/*.py $(DESTDIR)$(site3)/piupartslib/

	install -d $(DESTDIR)$(sharedir)/piuparts/lib
	install -m 0644 lib/*.sh $(DESTDIR)$(sharedir)/piuparts/lib/

install-master: build-master-stamp install-common
	install -d $(DESTDIR)$(libdir)/piuparts/
	install -m 0755 helpers/debiman-piuparts-distill/debiman-piuparts-distill $(DESTDIR)$(libdir)/piuparts/

	install -d $(DESTDIR)$(sharedir)/piuparts
	install -m 0755 piuparts-master piuparts-master-backend piuparts-report piuparts-analyze $(DESTDIR)$(sharedir)/piuparts/

	# do not install the templates (*.in, *.py, *.) nor __pycache__
	install -d $(DESTDIR)$(sharedir)/piuparts/master
	install -m 0755 $(filter-out %.in %.py %__pycache__,$(wildcard master-bin/*)) $(DESTDIR)$(sharedir)/piuparts/master/

	install -d $(DESTDIR)$(sharedir)/piuparts/known_problems
	install -m 0644 known_problems/*.conf $(DESTDIR)$(sharedir)/piuparts/known_problems/

	install -d $(DESTDIR)$(htdocsdir)
	install -m 0644 htdocs/*.* $(DESTDIR)$(htdocsdir)/

	install -d $(DESTDIR)$(htdocsdir)/images
	install -m 0644 htdocs/images/*.* $(DESTDIR)$(htdocsdir)/images/

	install -d $(DESTDIR)$(htdocsdir)/templates/mail
	install -m 0644 bug-templates/*.mail $(DESTDIR)$(htdocsdir)/templates/mail/

	#install -d $(DESTDIR)$(etcdir)/piuparts/known_problems
	#install -m 0644 known_problems/*.conf $(DESTDIR)$(etcdir)/piuparts/known_problems/

install-slave: install-common
	install -d $(DESTDIR)$(sbindir)
	install -m 0755 piuparts $(DESTDIR)$(sbindir)/

	install -d $(DESTDIR)$(sharedir)/piuparts
	install -m 0755 piuparts-slave $(DESTDIR)$(sharedir)/piuparts/

	# do not install the templates (*.in, *.py) nor __pycache__
	install -d $(DESTDIR)$(sharedir)/piuparts/slave
	install -m 0755 $(filter-out %.in %.py %__pycache__,$(wildcard slave-bin/*)) $(DESTDIR)$(sharedir)/piuparts/slave/

	install -d $(DESTDIR)$(etcdir)/piuparts
	@set -e -x ; \
	for d in $$(ls custom-scripts) ; do \
		install -d $(DESTDIR)$(etcdir)/piuparts/$$d ; \
		install -m 0755 custom-scripts/$$d/* $(DESTDIR)$(etcdir)/piuparts/$$d/ ; done

install: install-master install-slave


check:
	PYTHONPATH=. pytest

clean:
	rm -f build-stamp
	rm -f build-master-stamp
	rm -fr $(DOCS_GENERATED)
	rm -fr .doctrees/
	find . -iname '*.pyc' -type f -delete
	find . -iname __pycache__ -type d -delete
	rm -f $(SCRIPTS_GENERATED)
	$(RM) helpers/debiman-piuparts-distill/debiman-piuparts-distill
	$(MAKE) -C instances clean


# for maintainer convenience only
check-whitespace:
	grep -r --exclude-dir .git --exclude '*.pyc' --exclude '*.png' --exclude '*.ico' -E '\s+$$' . || echo "no trailing whitespace found"
	grep -r --exclude-dir .git --exclude '*.pyc' --exclude '*.png' --exclude '*.ico' -P ' \t' . || echo "no space-tab combo found"

# for maintainer convenience only
tg-deps:
	tg summary --graphviz | dot -T png -o deps.png
	xli deps.png &

=== debian/changelog ===
piuparts (1.4.4) unstable; urgency=medium

  [ Alexandre Detiste ]
  * remove dependency on python3-nose (Closes: #1018437)

  [ Jochen Sprickerhof ]
  * Move debootstrap to recommends

  [ Nicolas Dandrimont ]
  * Only report /usr-move failures when the end-state is bookworm or older
    (Closes: #1078598)
  * Fix go building from a VCS checkout
  * Makefile: install html files more reliably
  * Update distro aliases to match the current reality
  * Update suite configurations on piuparts.debian.org to match

  [ Gioele Barabucci ]
  * gitlab-ci/lint.yml: black: Show diff when check fails

 -- Nicolas Dandrimont <olasd@debian.org>  Tue, 24 Sep 2024 16:16:51 +0200

=== debian/control ===
Source: piuparts
Maintainer: piuparts developers team <piuparts-devel@alioth-lists.debian.net>
Uploaders: Nicolas Dandrimont <olasd@debian.org>,
 Andreas Beckmann <anbe@debian.org>,
 Holger Levsen <holger@debian.org>
Section: devel
Priority: optional
Standards-Version: 4.6.2
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 python3-all,
 python3-apt,
 python3-debian,
 python3-debianbts,
 python3-distro-info,
 python3-pytest,
 python3-sphinx,
 python3-yaml,
 golang-any,
Build-Depends-Indep:
 git,
Homepage: https://piuparts.debian.org
Vcs-Git: https://salsa.debian.org/debian/piuparts.git
Vcs-Browser: https://salsa.debian.org/debian/piuparts
XS-Go-Import-Path: salsa.debian.org/debian/piuparts

Package: piuparts
Architecture: all
Depends:
 piuparts-common (= ${binary:Version}),
# keep this list in sync with piuparts-slave-from-git-deps
 debsums,
 lsb-release,
 lsof,
 mount,
 python3-debian,
 ${python3:Depends},
 ${misc:Depends},
 ${sphinxdoc:Depends}
Recommends:
 adequate,
 debootstrap,
Suggests:
 schroot,
 docker.io,
Description: .deb package installation, upgrading, and removal testing tool
 piuparts tests that .deb packages (as used by Debian) handle
 installation, upgrading, and removal correctly. It does this by
 creating a minimal Debian installation in a chroot, and installing,
 upgrading, and removing packages in that environment, and comparing the
 state of the directory tree before and after. piuparts reports any
 files that have been added, removed, or modified during this process.
 .
 piuparts is meant as a quality assurance tool for people who create .deb
 packages to test them before they upload them to the Debian package archive.

Package: piuparts-master
Architecture: any
Built-Using: ${misc:Built-Using}
Depends:
 piuparts-common (>= ${source:Version}),
 piuparts-common (<< ${source:Version}+),
# keep this list in sync with piuparts-master-from-git-deps
 adduser,
 openssh-server,
 python3-debianbts,
 python3-setproctitle,
 tango-icon-theme,
 xz-utils,
 python3-yaml,
 ${python3:Depends},
 ${shlibs:Depends},
 ${misc:Depends},
Recommends:
 apache2 | httpd,
 ghostscript,
 python3-rpy2,
 r-base-dev,
 r-recommended,
 devscripts,
 libsoap-lite-perl,
Description: piuparts master components
 piuparts is meant as a quality assurance tool for people who create .deb
 packages to test them before they upload them to the Debian package archive.
 A master/slave piuparts installation is used for testing complete archives
 as it is done on https://piuparts.debian.org/.
 .
 This package provides the piuparts-master, which needs one or more slaves to
 operate. It also contains piuparts-report to generate web pages with the
 testing results as well as documentation.

Package: piuparts-master-from-git-deps
Architecture: all
Depends:
 git,
# this list is synced from piuparts-master
 adduser,
 openssh-server,
 python3-debianbts,
 python3-setproctitle,
 tango-icon-theme,
 xz-utils,
 python3-yaml,
# selected packages from piuparts-master Recommends
 apache2 | httpd,
 python3-rpy2,
# this list is synced from piuparts-common
 python3-apt,
 python3-distro-info,
 ${misc:Depends},
 ${python3:Depends},
Description: dependencies for running piuparts master from git
 piuparts is meant as a quality assurance tool for people who create .deb
 packages to test them before they upload them to the Debian package archive.
 A master/slave piuparts installation is used for testing complete archives
 as it is done on https://piuparts.debian.org/.
 .
 This metapackage provides all the dependencies needed for running a
 piuparts-master instance (including piuparts-report etc.) from git.

Package: piuparts-slave
Architecture: all
Depends:
 piuparts (= ${binary:Version}),
 piuparts-common (= ${binary:Version}),
# keep this list in sync with piuparts-slave-from-git-deps
 adduser,
 openssh-client,
 screen,
 sudo,
 ${misc:Depends},
 ${python3:Depends},
Suggests:
 schroot
Description: piuparts slave components
 piuparts is meant as a quality assurance tool for people who create .deb
 packages to test them before they upload them to the Debian package archive.
 A master/slave piuparts installation is used for testing complete archives
 as it is done on https://piuparts.debian.org/.
 .
 This package provides the piuparts slave components, which need a piuparts
 master to operate. See the documentation in the piuparts-master package.

Package: piuparts-slave-from-git-deps
Architecture: all
Depends:
 adequate,
 git,
 pkgconf,
# this list is synced from piuparts-slave
 adduser,
 openssh-client,
 screen,
 sudo,
# this list is synced from piuparts
 debsums,
 libjs-sphinxdoc,
 lsb-release,
 lsof,
 mount,
 python3-debian,
# this list is synced from piuparts-common
 python3-apt,
 python3-distro-info,
 ${misc:Depends},
 ${python3:Depends},
Recommends:
 debootstrap,
Description: dependencies for running piuparts slave from git
 piuparts is meant as a quality assurance tool for people who create .deb
 packages to test them before they upload them to the Debian package archive.
 A master/slave piuparts installation is used for testing complete archives
 as it is done on https://piuparts.debian.org/.
 .
 This metapackage provides all the dependencies needed for running a
 piuparts-slave instance from git.

Package: piuparts-common
Architecture: all
Depends:
# keep this list in sync with piuparts-{master,slave}-from-git-deps
 python3-apt,
 python3-distro-info,
 python3-urllib3,
 ${misc:Depends},
 ${python3:Depends},
Description: common piuparts components
 piupartslib, common library used by piuparts-master, -report, -analyze and
 -slave.
 .
 See https://piuparts.debian.org or the piuparts package to learn more about
 piuparts.

=== debian/tests/control ===
Tests: smoke-test
Depends: piuparts, debootstrap
Restrictions: needs-root

Tests: all-python-versions
Depends: piuparts, python3-all, debootstrap
Restrictions: needs-root

## piuparts 1.5.1

=== debian/changelog ===
piuparts (1.5.1) unstable; urgency=medium

  [ Nicolas Dandrimont ]
  * Handle situations where /dev/tty exists but is not connected
  * Don't crash when requesting chroot removal before it's initialized

  [ Jochen Sprickerhof ]
  * Allow running without PATH being set

 -- Nicolas Dandrimont <olasd@debian.org>  Fri, 15 Nov 2024 15:47:13 +0100

piuparts (1.5.0) unstable; urgency=medium

  [ Helmut Grohne ]
  * piuparts: reexecute via unshare when run as non-root
  * install piuparts to /usr/bin
  * suggest installing uidmap

  [ Jochen Sprickerhof ]
  * Add --bootstrapcmd to use alternative bootstrap commands

  [ Nicolas Dandrimont ]
  * bind-mount the minimal /dev devices if they can't be opened (Closes: #1084234)
  * packagesdb: resolve virtual packages when detecting dependency cycles
  * Add autopkgtest for unshared piuparts
  * Script updates for dracut-related packages

 -- Nicolas Dandrimont <olasd@debian.org>  Thu, 14 Nov 2024 12:19:16 +0100

## piuparts 1.6.0

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 prefix = /usr/local
-sbindir = $(prefix)/sbin
+bindir = $(prefix)/bin
 sharedir = $(prefix)/share
 mandir = $(sharedir)/man
 man1dir = $(mandir)/man1
@@ -30,7 +30,7 @@
 	-e 's/__PIUPARTS_VERSION__/$(version)/g' \
 	-e 's%@libdir@%$(libdir)%g' \
 	-e 's%@sharedir@%$(sharedir)%g' \
-	-e 's%@sbindir@%$(sbindir)%g' \
+	-e 's%@bindir@%$(bindir)%g' \
 	$< > $@
 endef
 
@@ -147,8 +147,8 @@
 	#install -m 0644 known_problems/*.conf $(DESTDIR)$(etcdir)/piuparts/known_problems/
 
 install-slave: install-common
-	install -d $(DESTDIR)$(sbindir)
-	install -m 0755 piuparts $(DESTDIR)$(sbindir)/
+	install -d $(DESTDIR)$(bindir)
+	install -m 0755 piuparts $(DESTDIR)$(bindir)/
 
 	install -d $(DESTDIR)$(sharedir)/piuparts
 	install -m 0755 piuparts-slave $(DESTDIR)$(sharedir)/piuparts/

=== instances/Makefile ===
ARCH				 = amd64
MIRROR				 = http://deb.debian.org/debian/
NUM_RUNNERS          = 4

ARCH_piu-slave-1und1-01		 = i386
MIRROR_piu-slave-1und1-01	 = http://mirror.1und1.de/debian/

NUM_RUNNERS_piu-slave-conova-01	 = 8


GENCONF		 = piuparts.conf.pejacevic
GENCONF		+= piuparts.conf.piu-slave-1und1-01
GENCONF		+= piuparts.conf.piu-slave-ubc-01
GENCONF		+= piuparts.conf.piu-slave-conova-01

all: $(GENCONF)

clean:
	$(RM) $(GENCONF)

piuparts.conf.%: piuparts.conf-template.pejacevic Makefile piuparts.conf-header.%
	cat piuparts.conf-header.$* > $@.tmp
	echo "" >> $@.tmp
	sed 's,@MIRROR@,$(or $(MIRROR_$*),$(MIRROR)),; s,@ARCH@,$(or $(ARCH_$*),$(ARCH)),; s,@NUM_RUNNERS@,$(or $(NUM_RUNNERS_$*),$(NUM_RUNNERS)),;' < $< >> $@.tmp
	mv $@.tmp $@

=== debian/changelog ===
piuparts (1.6.0) unstable; urgency=medium

  * Ignore /var/cache/debconf/tmp.ci/ (Closes: #1092667)
  * Extend allow-database policy-rc.d for firebird4.0 (Closes: #1095408)
  * Support versioned provides in metapackage generation
  * Record and ignore files affected by systemd-tmpfiles (Closes: #1036399)
  * Always use --allow-remove-essential on removals (Closes: #1010967, #1084173)

 -- Nicolas Dandrimont <olasd@debian.org>  Thu, 20 Mar 2025 22:02:58 +0100

=== debian/control ===
--- 
+++ 
@@ -41,10 +41,11 @@
  ${sphinxdoc:Depends}
 Recommends:
  adequate,
- debootstrap,
+ debootstrap | mmdebstrap,
 Suggests:
  schroot,
  docker.io,
+ uidmap,
 Description: .deb package installation, upgrading, and removal testing tool
  piuparts tests that .deb packages (as used by Debian) handle
  installation, upgrading, and removal correctly. It does this by
@@ -167,7 +168,7 @@
  ${misc:Depends},
  ${python3:Depends},
 Recommends:
- debootstrap,
+ debootstrap | mmdebstrap,
 Description: dependencies for running piuparts slave from git
  piuparts is meant as a quality assurance tool for people who create .deb
  packages to test them before they upload them to the Debian package archive.

=== debian/tests/control ===
Tests: smoke-test
Depends: piuparts, debootstrap, mmdebstrap
Restrictions: needs-root

Tests: all-python-versions
Depends: piuparts, python3-all, debootstrap
Restrictions: needs-root

Tests: unshare
Depends: piuparts, uidmap, debootstrap
Restrictions: needs-root, skippable

## piuparts 1.6.0build1

=== debian/changelog ===
piuparts (1.6.0build1) resolute; urgency=medium

  * No-change mass rebuild for Ubuntu 26.04 (LP: #2132257)

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 27 Jan 2026 13:29:27 +0000
